#include <audiodecoder.h>
#include <wine/winbase.h>
#include <wine/winerror.h>
#include <wine/driver.h>
#include <wine/msacm.h>
//#pragma pack(2)

class ACM_Decoder : public IAudioDecoder
{
    WAVEFORMATEX m_wstr;
    WAVEFORMATEX wf;
    char ext_info[64];
    HACMSTREAM srcstream;
    int m_status;
public:
    ACM_Decoder(WAVEFORMATEX*, void*);
    int GetMinSize();
    int Convert(unsigned char* in_data, Unsigned in_size,
	     unsigned char* out_data, Unsigned out_size,
	    Unsigned* size_read, Unsigned* size_written);
    int Close();
};
