#include <audioencoder.h>
extern "C"
{
#include "lame3.70/lame.h"
}
class MP3Encoder: public IAudioEncoder
{
    lame_global_flags gf;
    WAVEFORMATEX in_fmt;
public:
    MP3Encoder(WAVEFORMATEX* format);
    ~MP3Encoder();
    virtual int SetBitrate(int bitrate);
    virtual int SetQuality(int quality);
    virtual int GetFormatSize();
    virtual int GetFormat(char* extension, int size);
    virtual int Start();
    virtual int Convert(char* in_data, int in_size,
	     char* out_data, int out_size,
	    int* size_read, int* size_written);
    virtual int Close(char* out_data, 
		int out_size, int* size_read);
};
