class cPlayer
{
public:
    void *pvtData;
    cPlayer();
    virtual ~cPlayer();
    static int init();
    virtual int open(const char *filename);
    virtual int query(const char *filename,long *len,char **title);
    virtual int close();
    virtual int seek(long pos);
    virtual long tell();
    virtual int play();
    virtual int pause(int value);
    virtual int rewind();
    static int deinit();
    virtual long len();
    virtual int msize(int px,int py);
    virtual int manualsize(int yes);
    virtual int postype(int yes);
    virtual int hwtype(int yes);            
};

typedef
struct avmode_s
{
    int w,h,bpp;
    avmode_s *next;
} avmode_t;

extern avmode_t *avmodes;
